## $Id: batching.py 14310 2016-12-05 09:14:32Z henrik $
##
## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Batch processing for aaue documents.
"""
import grok
from waeup.ikoba.customers.batching import (
    CustomerProcessor,
    CustomerDocumentProcessorBase, ContractProcessorBase)
from ikobacustom.aaue.customers.interfaces import (
    IAAUECustomer,
    IAAUECustomerDocument, IAAUEContract)
from ikobacustom.aaue.interfaces import MessageFactory as _


class AAUECustomerProcessor(CustomerProcessor):
    """A batch processor for ICustomer objects.
    """
    util_name = 'aauecustomerprocessor'
    grok.name(util_name)
    name = _('AAUE Customer Processor')
    iface = IAAUECustomer


class AAUECustomerDocumentProcessor(CustomerDocumentProcessorBase):
    """A batch processor for IAAUECustomerDocument objects.
    """
    util_name = 'aauecustomerdocumentprocessor'
    grok.name(util_name)
    name = _('AAUE Customer Document Processor')
    iface = IAAUECustomerDocument
    factory_name = 'waeup.AAUECustomerDocument'


class AAUEContractProcessor(ContractProcessorBase):
    """A batch processor for IAAUEContract objects.
    """
    util_name = 'aauecontractprocessor'
    grok.name(util_name)
    name = _('AAUE Customer Contract Processor')
    iface = IAAUEContract
    factory_name = 'waeup.AAUEContract'