## $Id: contracts.py 14310 2016-12-05 09:14:32Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Customer contract components.
"""

import grok
from zope.component.interfaces import IFactory
from zope.interface import implementedBy
from waeup.ikoba.utils.helpers import attrs_to_fields
from waeup.ikoba.customers.interfaces import ICustomerNavigation
from waeup.ikoba.customers.contracts import ContractBase
from ikobacustom.aaue.interfaces import MessageFactory as _
from ikobacustom.aaue.customers.interfaces import (
    IAAUEContract, IAAUEContractEdit, IAAUEContractProcess,
    IAAUEContractOfficialUse)


class AAUEContract(ContractBase):
    """This is a sample contract.
    """

    grok.implements(
        IAAUEContractProcess,
        IAAUEContract,
        IAAUEContractEdit,
        ICustomerNavigation)

    contract_category = 'sample'

    form_fields_interface = IAAUEContract

    edit_form_fields_interface = IAAUEContractEdit

    ou_form_fields_interface = IAAUEContractOfficialUse

    check_docs_interface = IAAUEContract

AAUEContract = attrs_to_fields(AAUEContract)


# Contracts must be importable. So we might need a factory.
class AAUEContractFactory(grok.GlobalUtility):
    """A factory for contracts.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.AAUEContract')
    title = u"Create a new contract.",
    description = u"This factory instantiates new sample contract instances."

    def __call__(self, *args, **kw):
        return AAUEContract(*args, **kw)

    def getInterfaces(self):
        return implementedBy(AAUEContract)
