## $Id: export.py 14310 2016-12-05 09:14:32Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Exporters for aaue customer objects and subobjects.
"""
import grok
from waeup.ikoba.customers.export import (
    CustomerExporter, CustomerDocumentExporterBase, ContractExporterBase)
from ikobacustom.aaue.customers.interfaces import (
    IAAUECustomer, IAAUECustomerDocument, IAAUEContractProcess)
from ikobacustom.aaue.interfaces import MessageFactory as _

class AAUECustomerExporter(CustomerExporter):
    """Exporter for Customers.
    """
    iface = IAAUECustomer
    title = _(u'AAUE Customers')


class AAUECustomerDocumentExporter(CustomerDocumentExporterBase):
    """Exporter for documents.
    """
    grok.name('aauecustomerdocuments')
    iface = IAAUECustomerDocument
    title = _(u'AAUE Customer Documents')
    class_name = 'AAUECustomerDocument'


class AAUEContractExporter(ContractExporterBase):
    """Exporter for Contract instances.
    """
    grok.name('aauecontracts')
    iface = IAAUEContractProcess
    title = _(u'AAUE Customer Contracts')
    class_name = 'AAUEContract'
