## $Id: product.py 14310 2016-12-05 09:14:32Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
These are the products (e.g. licenses).
"""
import grok
from zope.component.interfaces import IFactory
from zope.interface import implementedBy
from waeup.ikoba.utils.helpers import attrs_to_fields
from waeup.ikoba.products.product import Product
from ikobacustom.aaue.products.interfaces import IAAUEProduct
from ikobacustom.aaue.interfaces import MessageFactory as _


class AAUEProduct(Product):
    """This is a product.
    """
    grok.implements(IAAUEProduct)
    grok.provides(IAAUEProduct)

    form_fields_interface = IAAUEProduct

AAUEProduct = attrs_to_fields(AAUEProduct)


class AAUEProductFactory(grok.GlobalUtility):
    """A factory for products.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.Product')
    title = u"Create a new product.",
    description = u"This factory instantiates new aaue products."

    def __call__(self, *args, **kw):
        return AAUEProduct(*args, **kw)

    def getInterfaces(self):
        return implementedBy(AAUEProduct)